'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _boardDrawer = require('./util/board-drawer');

var _boardDrawer2 = _interopRequireDefault(_boardDrawer);

var _canvas = require('./util/canvas');

var canvas = _interopRequireWildcard(_canvas);

var _rules = require('../rules');

var rules = _interopRequireWildcard(_rules);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Board draw's a Go Board
var Board = function (_React$PureComponent) {
  _inherits(Board, _React$PureComponent);

  function Board(props) {
    _classCallCheck(this, Board);

    var _this = _possibleConstructorReturn(this, _React$PureComponent.call(this, props));

    _this.handleBoardClick = function (e) {
      var mousePosition = canvas.calculateMousePosition(_this.canvas, e);
      var boardCoordinate = _this.drawer.calculateCoordinateFromMousePosition(mousePosition);

      if (rules.isCoordinateOnBoard(boardCoordinate, _this.drawer.boardSize)) {
        _this.props.onPositionClick(boardCoordinate);
      }
    };

    var size = props.size,
        width = props.width,
        height = props.height;


    _this.drawer = new _boardDrawer2.default(size, width, height);
    return _this;
  }

  Board.prototype.componentDidMount = function componentDidMount() {
    var _props = this.props,
        positions = _props.positions,
        width = _props.width,
        height = _props.height;

    var context = this.canvas.getContext('2d');

    this.canvas.width = width;
    this.canvas.height = height;

    if (context) {
      this.context = context;
      this.drawer.draw(this.context, positions);
    }
  };

  Board.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var positions = nextProps.positions;


    if (this.context) {
      this.drawer.draw(this.context, positions);
    }
  };

  Board.prototype.render = function render() {
    var _this2 = this;

    return _react2.default.createElement('canvas', { ref: function ref(c) {
        return _this2.canvas = c;
      }, onClick: this.handleBoardClick });
  };

  return Board;
}(_react2.default.PureComponent);

Board.defaultProps = {
  size: 19,
  positions: [],
  onPositionClick: function onPositionClick() {}
};
exports.default = Board;